unit Kombi3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    ListBox1: TListBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit2: TEdit;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    procedure ClearGrid;
    procedure GetWeightsMatrix;
    function isInPath(a: integer): boolean;
    function nextStep(realCount,cur: integer): integer;
    function Zhadina(realCount,cur: integer): integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Weights: array [0..100, 0..100] of integer;
  Path: array[0..100] of integer;

implementation

{$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.ClearGrid;
var
  i,j: integer;
begin
  for i:=1 to StringGrid1.RowCount-1 do
    for j:=1 to StringGrid1.ColCount-1 do
      StringGrid1.Cells[i,j]:='';
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  if Edit1.Text='' then
    MessageDlg(':     !', mtError, [mbOK], 0)
  else
    begin
      ListBox1.Items.Add(edit1.Text);
      Edit1.Text:='';
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
 i: integer;
begin
  StringGrid1.ColCount:= ListBox1.Items.Count+1;
  StringGrid1.RowCount:=ListBox1.Items.Count+1;
  for i:=0 to ListBox1.Items.Count-1 do
    begin
      StringGrid1.Cells[i+1,0]:=ListBox1.Items[i];
      StringGrid1.Cells[0,i+1]:=ListBox1.Items[i];
    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  i,j: integer;
  flag: real;
begin
  ClearGrid;
  for i:=1 to StringGrid1.ColCount-1 do
    begin
      StringGrid1.Cells[i,i]:='0';
      for j:=i+1 to StringGrid1.RowCount-1 do
        begin
          flag:=random;
          if (flag>0.5) then
          begin
            StringGrid1.Cells[i,j] := IntToStr(random(1000));
            StringGrid1.Cells[j,i] := StringGrid1.Cells[i,j];
          end;
        end;
    end;
end;

procedure TForm1.GetWeightsMatrix;
var
  i,j: integer;
begin
  for i:=0 to ListBox1.Items.Count-1 do
    Weights[i,i]:=0; //     
  for i:=0 to ListBox1.Items.Count-1 do
    for j:=i+1 to ListBox1.Items.Count-1 do
      if StringGrid1.Cells[i+1,j+1]=''
      then
        begin
          Weights[i,j]:=1000; // ,   
          Weights[j,i]:=1000; // 
        end
      else
        begin
          try //  
            Weights[i,j]:=StrToInt(StringGrid1.Cells[i+1,j+1]);
          except
            MessageDlg(':       !', mtError, [mbOK], 0);
          exit;
        end;
        // ?
        if Weights[i,j]<0 then begin
          MessageDlg(':      !', mtError, [mbOK], 0);
          exit;
        end;
        //  
        Weights[j,i]:=Weights[i,j];
      end; // else
end;

function TForm1.isInPath(a: integer): boolean;
var
  i:integer;
  stop:boolean;
begin
  i:=0;
  Result:=false;
  Stop:=false;
  while not Result and not stop do
    begin
      Result:=Path[i]=a;
      Stop:=(i=100) or (Path[i]=-1);
      inc(i);
    end;
end;

function TForm1.nextStep(realCount,cur: integer): integer;
var
  i,bliz,minIndex: integer;
begin
  bliz:=1000;
  minIndex:=0;
  for i:=0 to ListBox1.Items.Count-1 do
    begin
      if (i<>cur-1) and (Weights[cur-1,i]<bliz) and not isInPath(i+1)
        then
          begin
            minIndex:=i;
            bliz:=Weights[cur-1,i];
          end;
    end;
  //  
  i:=0;
  while (i<ListBox1.Items.Count) and (Path[i]<>-1) do inc(i);
  Path[i]:=minIndex+1;
  Result:=minIndex+1;
end;

function TForm1.Zhadina(realCount,cur: integer): integer;
var
  Summa,i: integer;
begin
  Summa:=0;
  Path[0]:=cur;
  // 
  for i:=0 to ListBox1.Items.Count-2 do
    cur:=nextStep(realcount, cur);
  // 
  for i:=1 to ListBox1.Items.Count-1 do
    Summa:=Summa+Weights[Path[i-1]-1,Path[i]-1];
  //    ,    
  Summa:=Summa+Weights[Path[ListBox1.Items.Count-1]-1,Path[0]-1];
  Result:=Summa;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  GetWeightsMatrix;
  Edit2.Text:=IntToStr(Zhadina(6,1));
end;

end.
